//-----------------------------------------------------------------------------
//  Copyright (C) 2005-2015 Thomas S. Ullrich 
//
//  This file is part of the Solitaire Mahjong project.
//
//  This file may be used under the terms of the GNU General Public License.
//  This project is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License.
//  
//  Author: Thomas S. Ullrich
//  Last update: June 1, 2007
//-----------------------------------------------------------------------------
#ifndef smPreferencesDialog_h
#define smPreferencesDialog_h
 
#include <QDialog>
#include "smDefinitions.h"
#include "smPreferencesDialog.h"
#include "ui_smPreferencesDialog.h"
 
class smPreferencesDialog : public QDialog
{
    Q_OBJECT

public:
    smPreferencesDialog(QWidget* parent = 0, Qt::WindowFlags fl = 0);
    ~smPreferencesDialog();
     
protected slots:
    void accept();
    void reject();
    void tileSizeComboActivated(int);
    void backgroundColorComboActivated(int);

protected:
    void showEvent(QShowEvent*);
    void hideEvent(QHideEvent*);
    
private:
    Ui::smPreferencesDialog ui;
    void init();
    void setTilePixmap(smTileSetId, smTileSize);
};
 
#endif
